/*
  Images in Shared Memory (ism)
  Lŉ摜(f)Lf[^\ Ver.1.01
  
  ӁFism_data.h̃o[ẂAism_data.txtɍ킹ĂB
  ism_data.c̃o[WƂ͓ƗĊǗĂ̂ŁAKł͂ȂB
  
  _ł1.xxŌ݊ێB
  
  2012/07/25 Ver.1.00	{\̍\z
  2012/10/25 Ver.1.01	ism_data\̂̒ǉIύX
*/
#ifndef __ISM_DATA_H__
#define __ISM_DATA_H__

#ifdef _WIN32
#include <windows.h>
#endif
#include "s_sharemem.h"

// ism_magicɃZbg鐔
// 'i''s'̏ɃZbg
#define	ISM_ID_MAGIC	(unsigned short)0x7369	// 'i'+'s'Intelzu

// ism_data ̃o[WԍB_ł0B
// \1+x/100ɂB(ex. 1.00)
#define ISM_VERSION	(unsigned short)1

/*
  ismňf[^tH[}bg
  _łRGB̂݃T|[gBIɂMJPEGAYUV\
*/
typedef enum {ISM_RGB=0,
	      // ISM_MJPEG ܂
	      // ISM_YUVV  ܂
	      ISM_MAX}
  ism_color_mode;

// fourcc̃Xg
extern unsigned long ism_fourcc[]; // ̂ ism_data.c ɑ

// ݎ\\̒`
// ʕbPʂ\ł邱ƂBs_time݊
#ifdef _WIN32
typedef	FILETIME	ism_time;
#else
typedef struct timeval	ism_time;
#endif

typedef struct {
  unsigned short	ism_magic;	// ismł邱ƂMAGICR[h
  unsigned short	version;	// ism̃o[Wԍ
  unsigned short	width;		// 摜̉
  unsigned short	height;		// 摜̏c
  unsigned long		fourcc;		// f[^tH[}bgFOURCC
  unsigned long		offset;		// f[^ʒuւ̃ItZbg
  unsigned long		datasize;	// f[^TCY(JPEG̉σTCY)
  unsigned long		maxsize;	// f[^̍őTCY
  // (maxsize̐l:width*height*3)
  ism_time		uptime;		// XV
} ism_head;

// L(ssm_data)ɑ΂֐
// ̊֐ism_datał邩ۂۂɔfĂB
// 擾łism_datał邪Aism_data\͍̂ȂB
ism_head *ism_get_head_from_ssm(ssm_data *ssm);
ism_head *ism_copy_head_from_ssm(ism_head *pismh,ssm_data *ssm);
// id璼ism_head()o
int ism_is_exist_image_shared_memory(char id[]);
ism_head *ism_copy_head_from_id(ism_head *pismh,char id[]);

// ism_data\
typedef struct {
  ssm_data ssm;		// 擪ssm_dataĂ
  ism_head *head;	// ism_head|C^̃Rs[(̒lssm_data)
  void *data;		// f[^|C^ւ̃Rs[(̒lssm_data)
  void *buffer;		// f[^ǂݏ̂߂̃obt@(NULL͖m)
} ism_data;

// ism_datač쐬֐
ism_data *ism_get_image_shared_memory(char id[]);
ism_data *ism_alloc_image_shared_memory(char id[],
					unsigned short width,
					unsigned short height,
					ism_color_mode ism_color);
void ism_free_image_shared_memory(ism_data *ism);

// RGBpismmۊ֐
#define ism_alloc_image_shared_memory_rgb(id,w,h)	\
  ism_alloc_image_shared_memory(id,w,h,ISM_RGB)

// ism_data  eo
#define ism_get_head(ism)	(ism_head *)((ism)==NULL?NULL:((ism)->head))
#define ism_get_data(ism)	(char *)((ism)==NULL?NULL:((ism)->data))
#define ism_get_buffer(ism)	(char *)((ism)==NULL?NULL:((ism)->buffer))

// ism_headɊւ֐(Ƀ}Nism_dataɂΉ)
#define ism_head_get_version(ismh)				\
  (float)((ismh)==NULL?0.0:1.0+(float)ismh->version/100.0)
#define ism_head_get_width(ismh)		\
  (unsigned short)((ismh)==NULL?0:ismh->width)
#define ism_head_get_height(ismh)		\
  (unsigned short)((ismh)==NULL?0:ismh->height)
ism_color_mode ism_head_get_color_mode(ism_head *ismh);

// ism_dataΉdefine
#define ism_get_version(ism)	ism_head_get_version(ism_get_head(ism))
#define ism_get_width(ism)	ism_head_get_width(ism_get_head(ism))
#define ism_get_height(ism)	ism_head_get_height(ism_get_head(ism))
#define ism_get_color_mode(ism)	ism_head_get_color_mode(ism_get_head(ism))

// 摜f[^̎oERs[֐
void *ism_copy_data_fast(void *dst,ism_data *ism);
// ㉺]܂߂Rs[
#ifdef _WIN32
void *ism_copy_data(void *dst,ism_data *ism);
#else
#define ism_copy_data(dst,ism)	ism_copy_data_fast(dst,ism)
#endif

// 摜f[^̏݁ERs[֐
void *ism_put_data_fast(ism_data *ism,void *src,unsigned long datasize);
// ㉺]܂߂Rs[
#ifdef _WIN32
void *ism_put_data(ism_data *ism,void *src,unsigned long datasize);
#else
#define ism_put_data(dst,ism,size)	ism_put_data_fast(dst,ism,size)
#endif

// ism_timeɊւ֐
void ism_time_init(ism_time *lasttime);
void ism_time_get_now_time(ism_time *lasttime);

// ism_data̍XV҂
ism_time *ism_head_wait_refresh(ism_head *ismh,ism_time *lasttime);
// ism_dataΉdefine
#define ism_wait_refresh(ism,lasttime)			\
  ism_head_wait_refresh(ism_get_head(ism),lasttime)

// ismf[^XVɊւ֐
void ism_head_update_datasize(ism_head *ismh,unsigned long datasize);
void ism_head_update_time(ism_head *ismh,ism_time *lasttime);
void ism_head_update_time_now(ism_head *ismh);
void ism_head_update(ism_head *ismh,unsigned long datasize);
// ism_dataΉdefine
#define ism_update_datasize(ism,datasize)		\
  ism_head_update_datasize(ism_get_head(ism),datasize)
#define ism_update_time(ism,lasttime)			\
  ism_head_update_time(ism_get_head(ism),lasttime)
#define ism_update_time_now(ism)			\
  ism_head_update_time_now(ism_get_head(ism))
#define ism_update(ism,datasize)			\
  ism_head_update(ism_get_head(ism),datasize)

#endif
